<?php
/**
 * @version		$Id$
 * @author		NooTheme
 * @package		Joomla.Site
 * @subpackage	mod_noo_k2_categoryitem
 * @copyright	Copyright (C) 2013 NooTheme. All rights reserved.
 * @license		License GNU General Public License version 2 or later; see LICENSE.txt, see LICENSE.php
 */

// no direct access
defined('_JEXEC') or die('Restricted access'); 

if (file_exists(JPATH_SITE.'/components/com_k2/helpers/route.php')){
	require_once (JPATH_SITE.'/components/com_k2/helpers/route.php');
}

abstract class modNooK2CategoryItemHelper {
	
	public static function getList(&$params){
		if (class_exists('K2Model')){
			$app = JFactory::getApplication();
			$user = JFactory::getUser();
			$db = JFactory::getDbo();
			
			$jnow = JFactory::getDate();
			$now = $jnow->toSql();
			$nullDate = $db->getNullDate();
			
			$query = $db->getQuery(true);
						
			$cids = $params->get('k2catid',array());
			
			JArrayHelper::toInteger($cids);
			
			if (count($cids) > 0){
				foreach ($cids as $k=>$cid){
					if (!$cid)
						unset($cids[$k]);
				}
			}
			
			$query->select('k2c.*')
				->from('#__k2_categories AS k2c');
			
			if (count($cids) > 0){
				$query->where('k2c.id IN ('.implode(',',$cids).')');
			}
			
			$query->where('k2c.published = 1')
				->where('k2c.trash = 0')
				->where("k2c.access IN(".implode(',', $user->getAuthorisedViewLevels()).")");
			if ($app->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query->where("k2c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
			}
			
			$db->setQuery($query);
			//$categories = new stdClass();
			$categories = $db->loadObjectList();
			if (count($categories) > 0){
				foreach ($categories as $category):
					$items = self::getK2Items($category->id,$params);
					$category->items = $items;
					$category->link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($category->id.':'.urlencode($category->alias))));
				endforeach;
			}
			return $categories;
		}
		return array();
	}
	
	public static function hashK2Children($parentId){
		$user = JFactory::getUser();
        $aid = (int)$user->get('aid');
        $id = (int)$parentId;
        $db = JFactory::getDBO();
        $query = "SELECT * FROM #__k2_categories WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();

        if (count($rows))
        {
            return true;
        }
        else
        {
            return false;
        }
	}
	
	public static function getK2Children($parentId,&$params){
		$user = JFactory::getUser();
        $aid = (int)$user->get('aid');
        $catid = (int)$catid;
        $db = JFactory::getDBO();
        $query = "SELECT * FROM #__k2_categories WHERE parent={$parentId} AND published=1 AND trash=0 AND access<={$aid} ORDER BY ordering ";
        $db->setQuery($query,0,$params->get('count_children',4));
        $rows = $db->loadObjectList();
        return $rows;
	}
	
	public static function getK2Items($categoryId,&$params){
		jimport('joomla.filesystem.file');
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$query = $db->getQuery(true);
		
		$componentParams = JComponentHelper::getParams('com_k2');
		
		$jnow = JFactory::getDate();
		$now = $jnow->toSql();
		$nullDate = $db->getNullDate();
		
		$query->select('i.*,c.alias AS categoryalias')
				->from('#__k2_items AS i')
				->innerJoin('#__k2_categories AS c ON c.id = i.catid')
				->where('i.published = 1 AND i.trash = 0 AND c.published = 1 AND c.trash = 0 ')
				->where('i.catid = '.(int)$categoryId)
				->where("i.access IN(".implode(',', $user->getAuthorisedViewLevels()).")");
		if ($app->getLanguageFilter())
		{
			$languageTag = JFactory::getLanguage()->getTag();
			$query->where("i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
		}
		$query->where("( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now).")")
				->where("(i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )");
		
		$ordering = $params->get('sort_order_field','created');
		$dir = $params->get('sort_order','DESC');
		$query->order('i.'.$ordering.' '.$dir);
		
		$db->setQuery($query,0,($params->get('leading',1)+$params->get('intro',4)));
		$items = $db->loadObjectList();
		
		foreach ($items as $item){
			$item->image = '';
			
			if ($params->get('leading_image')){
				$date = JFactory::getDate($item->modified);
				$timestamp = '?t='.$date->toUnix();

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg'))
				{
					$item->imageXSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageXSmall .= $timestamp;
					}
				}

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg'))
				{
					$item->imageSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageSmall .= $timestamp;
					}
				}

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg'))
				{
					$item->imageMedium = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageMedium .= $timestamp;
					}
				}

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg'))
				{
					$item->imageLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageLarge .= $timestamp;
					}
				}

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg'))
				{
					$item->imageXLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageXLarge .= $timestamp;
					}
				}

				if (JFile::exists(JPATH_SITE.'/media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg'))
				{
					$item->imageGeneric = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';
					if ($componentParams->get('imageTimestamp'))
					{
						$item->imageGeneric .= $timestamp;
					}
				}

				$image = 'image'.$params->get('leading_image_size', 'Small');
				if (isset($item->$image))
					$item->image = $item->$image;
			}
			$item->description = self::trimChar(strip_tags($item->introtext),$params->get('leading_des_lenght',150));
			$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
		}
		
		return $items;
	}
	
	/**
	 * Method trim string with max specify
	 * @param string $string
	 * @param int $maxChar
	 * 
	 * @return string
	 */
	public static function trimChar($string,$maxChar = 50){
		
		if (strlen($string) > $maxChar)
			return JString::substr($string,0,$maxChar).' ...';
			
		return $string;
	}
}
