<?php
/**
 * @version		$Id$
 * @author		NooTheme
 * @package		Joomla.Site
 * @subpackage	mod_noo_k2items
 * @copyright	Copyright (C) 2013 NooTheme. All rights reserved.
 * @license		License GNU General Public License version 2 or later; see LICENSE.txt, see LICENSE.php
 */

// no direct access
defined('_JEXEC') or die('Restricted access'); 

if (file_exists(JPATH_SITE.'/components/com_k2/helpers/route.php')){
	require_once (JPATH_SITE.'/components/com_k2/helpers/route.php');
}

if (file_exists(JPATH_SITE.'/components/com_k2/helpers/utilities.php')) {
	require_once (JPATH_SITE.'/components/com_k2/helpers/utilities.php');
}

abstract class modNooK2ItemsHelper {
	
	public static function getList(&$params){
		if (class_exists('K2Model')){
			if ($params->get('source') == 'specific'){
				return self::getK2Items(0,$params);
			}else{
				return self::getItemByCategory($params);
			}
		}
		return array();
	}
	
	public static function getItemByCategory(&$params){
		if (class_exists('K2Model')){
			$app = JFactory::getApplication();
			$user = JFactory::getUser();
			$db = JFactory::getDbo();
			
			$jnow = JFactory::getDate();
			$now = $jnow->toSql();
			$nullDate = $db->getNullDate();
			
		
			
			$query = $db->getQuery(true);
			
			$cids = $params->get('k2catid',array());
			
			JArrayHelper::toInteger($cids);
			
			if (count($cids) > 0){
				foreach ($cids as $k=>$cid){
					if (!$cid)
						unset($cids[$k]);
				}
			}
			
			$query->select('k2c.*')
				->from('#__k2_categories AS k2c');
			
			if ($cids){
				$query->where('k2c.id IN ('.implode(',',$cids).')');
			}
			
			$query->where('k2c.published = 1')
				->where('k2c.trash = 0')
				->where("k2c.access IN(".implode(',', $user->getAuthorisedViewLevels()).")");
			if ($app->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query->where("k2c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
			}
			
			$db->setQuery($query);
			$categories = $db->loadObjectList();
		
			$items = array();
			$itemsByCategory = array();
			if (count($categories) > 0){
				foreach ($categories as $category):
					$itemsByCategory[] = self::getK2Items($category->id,$params);
				endforeach;
			}
			$itemArr = array();
			foreach ($itemsByCategory as $k=>$value){
				foreach ($value as $v){
					$itemArr[] = $v->id;
					//$items[] = $v;
				}
			}
			if (count($itemArr) && ($data = self::getK2Items($itemArr, $params,true))){
				$items = $data;
			}
			return $items;
		}
		return array();
	}

	
	public static function getK2Items($categoryId,&$params,$isItem = false){
		jimport('joomla.filesystem.file');
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		
		
		$limit = $params->get('count',3);
		
		$limitstart = $app->input->get('limitstart',0,'int');
		
		$componentParams = JComponentHelper::getParams('com_k2');
		
		$jnow = JFactory::getDate();
		$now = $jnow->toSql();
		$nullDate = $db->getNullDate();
		
		if (!$isItem){
			$cids = $params->get('k2catid',array());
			JArrayHelper::toInteger($cids);
			
			if (count($cids) > 0){
				foreach ($cids as $k=>$cid){
					if (!$cid)
						unset($cids[$k]);
				}
			}
		}
		$items = array();
		if ($params->get('source') == 'specific')
		{
			$value = $params->get('items');
			$current = array();
			if (is_string($value) && !empty($value))
				$current[] = $value;
			if (is_array($value))
				$current = $value;

			foreach ($current as $id)
			{
				$query = $db->getQuery(true);
				$query->select('i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams')
					->from('#__k2_items as i')
					->leftJoin('#__k2_categories c ON c.id = i.catid')
					->where('i.id ='.$id)
					->where('i.published = 1')
					->where(' c.trash = 0')
					->where("i.access IN(".implode(',', $user->getAuthorisedViewLevels()).") ")
					->where("c.access IN(".implode(',', $user->getAuthorisedViewLevels()).")")
					->where("( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now).")")
					->where("(i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )")
					;
				if ($app->getLanguageFilter())
				{
					$languageTag = JFactory::getLanguage()->getTag();
					$query->where("i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
					$query->where("c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
				}
				$db->setQuery($query);
				$item = $db->loadObject();
				if ($item)
					$items[] = $item;

			}
		}else{
			$query = $db->getQuery(true);
			$query->select('i.*,CASE WHEN i.modified = 0 THEN i.created ELSE i.modified END as lastChanged,c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams')
					->from('#__k2_items AS i')
					->innerJoin('#__k2_categories AS c ON c.id = i.catid')
					->where('i.published = 1 AND i.trash = 0 AND c.published = 1 AND c.trash = 0 ')
					->where("i.access IN(".implode(',', $user->getAuthorisedViewLevels()).")");
			if ($isItem){
				$query->where('i.id IN ('.implode(',',$categoryId).')');
			}else{
				if ($categoryId > 0){
					$query->where('i.catid = '.$categoryId);
				}elseif (count($cids)){
					$query->where('i.catid IN ('.implode(',',$cids).')');
				}
			}
						
			if ($app->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query->where("i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
				$query->where("c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")");
			}
			
			
			$query->where("( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now).")")
					->where("(i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )");
			
			$ordering = $params->get('sort_order_field','id');
			$dir = $params->get('sort_order','DESC');
			
			if ($params->get('featureditems') == '0')
				$query->where('i.featured != 1');
			if ($params->get('featureditems') == '2')
				$query->where('i.featured = 1');
			
			if ($params->get('videosonly') == '1')
				$query->where("(i.video IS NOT NULL AND i.video!='')");
	
			if ((trim($params->get('sort_order_field')) == 'hits') && $params->get('popularityrange'))
				$query->where("i.created > DATE_SUB('{$now}',INTERVAL ".$params->get('popularityrange')." DAY) ");
	
			
			if (trim($params->get('sort_order_field')) == 'rating'){
				$query->select('(r.rating_sum/r.rating_count) AS rating');
				$query->leftJoin('#__k2_rating AS r ON r.itemID = i.id');
				$query->order('rating '.$dir);
			}elseif (trim($params->get('sort_order_field')) == 'comments'){
				$query->select('COUNT(comments.id) AS num_comments');
				
				if ($params->get('popularityrange'))
					$query->where("i.created > DATE_SUB('{$now}',INTERVAL ".$params->get('popularityrange')." DAY) ");
				
				$query->where('comments.published = 1 ');
				
				$query->leftJoin('#__k2_comments AS comments ON comments.itemID = i.id');
				$query->group('i.id');
				$query->order('num_comments '.$dir);
			}elseif (trim($params->get('sort_order_field')) == 'ordering'){
				if ($params->get('featureditems') == '2')
					$ordering = 'featured_ordering';
				$query->order('i.'.$ordering.' '.$dir);
			}elseif ($params->get('sort_order_field') == 'modified'){
				$query->order('lastChanged '.$dir);
			}elseif (trim($params->get('sort_order_field')) == 'rand'){
				$query->order(' RAND()');
			}else{
				$query->order('i.'.$ordering.' '.$dir);
			}
			
			$db->setQuery($query,$limitstart,$limit);
			
			$items = $db->loadObjectList();
		}
		
		$model = K2Model::getInstance('Item', 'K2Model');
		$rows = array();
		
		if (count($items))
		{
			foreach ($items as $item){
				$item->event = new stdClass;

				//Clean title
				$item->title = JFilterOutput::ampReplace($item->title);
				
				if ($params->get('itemimage')){

					if (JFile::exists(JPATH_SITE.'/media/k2/items/src/'.md5("Image".$item->id).'.jpg')){
	               		$image = JURI::base().'/media/k2/items/src/'.md5("Image".$item->id).'.jpg';         
	               		$item->image = self::renderImage($image,$params);
					}
				}
				
				//Read more link
				$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));

				//Tags
				if ($params->get('itemtags'))
				{
					$tags = $model->getItemTags($item->id);
					for ($i = 0; $i < sizeof($tags); $i++)
					{
						$tags[$i]->link = JRoute::_(K2HelperRoute::getTagRoute($tags[$i]->name));
					}
					$item->tags = $tags;
				}
				//Category link
				if ($params->get('itemcategory'))
					$item->categoryLink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));

				//Extra fields
				if ($params->get('itemextrafields'))
				{
					$item->extra_fields = $model->getItemExtraFields($item->extra_fields, $item);
				}

				//Comments counter
				if ($params->get('itemcommentscounter'))
					$item->num_comments = $model->countItemComments($item->id);

				//Attachments
				if ($params->get('itemattachments'))
					$item->attachments = $model->getItemAttachments($item->id);
				
				$dispatcher = JDispatcher::getInstance();
				JPluginHelper::importPlugin('content');
					
				//Video
				if ($params->get('itemvideo'))
				{
					$params->set('vfolder', 'media/k2/videos');
					$params->set('afolder', 'media/k2/audio');
					$item->text = $item->video;
					$dispatcher->trigger('onContentPrepare', array('mod_k2_content.', &$item, &$params,&$limitstart));            
					$item->video = $item->text;
				}
				
				// Introtext
				$item->text = '';
				if ($params->get('itemintrotext'))
				{
					// Word limit
					if ($params->get('leading_des_lenght'))
					{
						$item->text .= K2HelperUtilities::wordLimit(strip_tags($item->introtext), $params->get('leading_des_lenght'));
					}
					else
					{
						$item->text .= strip_tags($item->introtext);
					}
				}
				
				$params->set('parsedInModule', 1);
				// for plugins to know when they are parsed inside this module

				if ($params->get('JPlugins', 1))
				{
					$results = $dispatcher->trigger('onBeforeDisplay', array(&$item, &$params, $limitstart));
					$item->event->BeforeDisplay = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onAfterDisplay', array(&$item, &$params, $limitstart));
					$item->event->AfterDisplay = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onAfterDisplayTitle', array(&$item, &$params, $limitstart));
					$item->event->AfterDisplayTitle = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onBeforeDisplayContent', array(&$item, &$params, $limitstart));
					$item->event->BeforeDisplayContent = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onAfterDisplayContent', array(&$item, &$params, $limitstart));
					$item->event->AfterDisplayContent = trim(implode("\n", $results));

					$dispatcher->trigger('onPrepareContent', array(&$item, &$params, $limitstart));
				}
				//Init K2 plugin events
				$item->event->K2BeforeDisplay = '';
				$item->event->K2AfterDisplay = '';
				$item->event->K2AfterDisplayTitle = '';
				$item->event->K2BeforeDisplayContent = '';
				$item->event->K2AfterDisplayContent = '';
				$item->event->K2CommentsCounter = '';
				if ($params->get('K2Plugins', 1))
				{
					//K2 plugins
					JPluginHelper::importPlugin('k2');
					$results = $dispatcher->trigger('onK2BeforeDisplay', array(&$item, &$params, $limitstart));
					$item->event->K2BeforeDisplay = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onK2AfterDisplay', array(&$item, &$params, $limitstart));
					$item->event->K2AfterDisplay = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onK2AfterDisplayTitle', array(&$item, &$params, $limitstart));
					$item->event->K2AfterDisplayTitle = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onK2BeforeDisplayContent', array(&$item, &$params, $limitstart));
					$item->event->K2BeforeDisplayContent = trim(implode("\n", $results));

					$results = $dispatcher->trigger('onK2AfterDisplayContent', array(&$item, &$params, $limitstart));
					$item->event->K2AfterDisplayContent = trim(implode("\n", $results));

					$dispatcher->trigger('onK2PrepareContent', array(&$item, &$params, $limitstart));

					if ($params->get('itemCommentsCounter'))
					{
						$results = $dispatcher->trigger('onK2CommentsCounter', array(&$item, &$params, $limitstart));
						$item->event->K2CommentsCounter = trim(implode("\n", $results));
					}

				}
				// Restore the intotext variable after plugins execution
                $item->introtext = $item->text;

				//Clean the plugin tags
				$item->introtext = preg_replace("#{(.*?)}(.*?){/(.*?)}#s", '', $item->introtext);

				//Author
				if ($params->get('itemauthor'))
				{
					if (!empty($item->created_by_alias))
					{
						$item->author = $item->created_by_alias;
						$item->authorGender = NULL;
						$item->authorDescription = NULL;
						if ($params->get('itemauthoravatar'))
							$item->authorAvatar = K2HelperUtilities::getAvatar('alias');
						$item->authorLink = Juri::root(true);
					}
					else
					{
						$author = JFactory::getUser($item->created_by);
						$item->author = $author->name;
						$query = $db->getQuery(true);
						$query->select('description,gender')
							->from('#__k2_users')
							->where("userID=".(int)$author->id);
						
						$db->setQuery($query, 0, 1);
						$result = $db->loadObject();
						if ($result)
						{
							$item->authorGender = $result->gender;
							$item->authorDescription = $result->description;
						}
						else
						{
							$item->authorGender = NULL;
							$item->authorDescription = NULL;
						}

						if ($params->get('itemauthoravatar'))
						{
							$item->authorAvatar = K2HelperUtilities::getAvatar($author->id, $author->email, $componentParams->get('userImageWidth'));
						}
						//Author Link
						$item->authorLink = JRoute::_(K2HelperRoute::getUserRoute($item->created_by));
					}
				}
				
				// Extra fields plugins
				if (is_array($item->extra_fields))
				{
					foreach ($item->extra_fields as $key => $extraField)
					{
						if ($extraField->type == 'textarea' || $extraField->type == 'textfield')
						{
							$tmp = new JObject();
							$tmp->text = $extraField->value;
							if ($params->get('JPlugins', 1))
							{
								$dispatcher->trigger('onPrepareContent', array(&$tmp, &$params, $limitstart));
							}
							if ($params->get('K2Plugins', 1))
							{
								$dispatcher->trigger('onK2PrepareContent', array(&$tmp, &$params, $limitstart));
							}
							$extraField->value = $tmp->text;
						}
					}
				}
			$rows[] = $item;
			}
		}
		return $rows;
	}
	
	public static function renderImage($imageSrc,$params){
    	$imageHelper = NooImageHelper::getInstance();
    	$imageUrl = '';
    	
    	if ($params->get('thumbnail_mode') != 'none' && $imageHelper->sourceExited($imageSrc)) {
    		$imageUrl = $imageHelper->resize($imageSrc,$params->get('image_width'),$params->get('image_height'),($params->get('thumbnail_mode') =='crop' ? true:false),$params->get('use_ratio',1));
    		if ($imageUrl){
    			return $imageUrl;
    		}
    	}else {
    		return $imageSrc;
    	}
    }
	
	/**
	 * Method trim string with max specify
	 * @param string $string
	 * @param int $maxChar
	 * 
	 * @return string
	 */
	public static function trimChar($string,$maxChar = 50){
		
		if (strlen($string) > $maxChar)
			return JString::substr($string,0,$maxChar).' ...';
			
		return $string;
	}
}

if (!class_exists('NooImageHelper')){
	if (!defined('DS'))
		define('DS',DIRECTORY_SEPARATOR);
		
	 jimport('joomla.filesystem.file');
	 jimport('joomla.filesystem.folder');
	 
	class NooImageHelper {
	/**
         * Identifier of the cache path.
         *
         * @access private
         * @param string $_cachePath
         */
        var $_cachePath;

        /**
         * Identifier of the path of source.
         *
         * @access private
         * @param string $_imageBase
         */
        var $_imageBase;

        /**
         * Identifier of the image's extensions
         *
         * @access public
         * @param array $types
         */
        var $types = array();

        /**
         * Identifier of the quantity of thumnail image.
         *
         * @access public
         * @param string $_quality
         */
        var $_quality = 90;

        /**
         * Identifier of the url of folder cache.
         *
         * @access public
         * @param string $_cacheURL
         */
        var $_cacheURL;


        /**
         * constructor
         */
        function __construct($config = array())
        {
            $this->types = array(1 => "gif", "jpeg", "png", "swf", "psd", "wbmp");
            $this->_imageBase = JPATH_SITE . DS .'/images' . DS;
            $this->_cachePath = $this->_imageBase . 'resized' . DS;
            $this->_cacheURL = 'images/resized/';
        }


        /**
         * get a instance of NooImageHelper object.
         *
         * This method must be invoked as:
         * <pre>  $NooImageHelper = &NooImageHelper::getInstace();</pre>
         *
         * @static.
         * @access public,
         */
        public static function &getInstance()
        {
            static $instance = null;
            if (!$instance) {
                $instance = new NooImageHelper();
            }
            return $instance;
        }


        /**
         * crop or resize image
         *
         *
         * @param string $image path of source.
         * @param integer $width width of thumnail
         * @param integer $height height of thumnail
         * @param boolean $aspect whether to render thumnail base on the ratio
         * @param boolean $crop whether to use crop image to render thumnail.
         * @access public,
         */
        function resize($image, $width, $height, $crop = true, $aspect = true)
        {
            // get image information


            if (!$width || !$height)
                return '';

            $image = str_replace(JURI::base(), '', $image);

            $imagSource = JPATH_SITE . DS . str_replace('/', DS, $image);

            if (!file_exists($imagSource) || !is_file($imagSource)) {
                return '';
            }
            $filetime = filemtime($imagSource);
            $size = getimagesize($imagSource);
            // if it's not a image.
            if (!$size) {
                return '';
            }

            // case 1: render image base on the ratio of source.
            $x_ratio = $width / $size[0];
            $y_ratio = $height / $size[1];

            // set dst, src
            $dst = new stdClass();
            $src = new stdClass();
            $src->y = $src->x = 0;
            $dst->y = $dst->x = 0;

            if ($width > $size[0])
                $width = $size[0];
            if ($height > $size[1])
                $height = $size[1];

            if ($crop) { // processing crop image
                $dst->w = $width;
                $dst->h = $height;
                if (($size[0] <= $width) && ($size[1] <= $height)) {
                    $src->w = $width;
                    $src->h = $height;
                } else {
                    if ($x_ratio < $y_ratio) {
                        $src->w = ceil($width / $y_ratio);
                        $src->h = $size[1];
                    } else {
                        $src->w = $size[0];
                        $src->h = ceil($height / $x_ratio);
                    }
                }
                $src->x = floor(($size[0] - $src->w) / 2);
                $src->y = floor(($size[1] - $src->h) / 2);
            } else { // processing resize image.
                $src->w = $size[0];
                $src->h = $size[1];
                if ($aspect) { // using ratio
                    if (($size[0] <= $width) && ($size[1] <= $height)) {
                        $dst->w = $size[0];
                        $dst->h = $size[1];
                    } else if (($size[0] <= $width) && ($size[1] <= $height)) {
                        $dst->w = $size[0];
                        $dst->h = $size[1];
                    } else if (($x_ratio * $size[1]) < $height) {
                        $dst->h = ceil($x_ratio * $size[1]);
                        $dst->w = $width;
                    } else {
                        $dst->w = ceil($y_ratio * $size[0]);
                        $dst->h = $height;
                    }
                } else { // resize image without the ratio of source.
                    $dst->w = $width;
                    $dst->h = $height;
                }
            }
            //
            $ext = substr(strrchr($image, '.'), 1);
            $thumnail = substr($image, 0, strpos($image, '.')) . "_{$width}_{$height}." . $ext;
            $imageCache = $this->_cachePath . str_replace('/', DS, $thumnail);

            if (file_exists($imageCache)) {
            	
            	$filetimecache = filemtime($imageCache);
            	if($filetime<$filetimecache){
	                $smallImg = getimagesize($imageCache);
	                if (($smallImg[0] == $dst->w && $smallImg[1] == $dst->h)) {
	                    return $this->_cacheURL . $thumnail;
	                }
            	}
            }

            if (!file_exists($this->_cachePath) && !JFolder::create($this->_cachePath)) {
                return '';
            }

            if (!$this->makeDir($image)) {
                return '';
            }

            // resize image
            $this->_resizeImage($imagSource, $src, $dst, $size, $imageCache);

            return $this->_cacheURL . $thumnail;
        }


        /**
         * render image from other server. // this is pending.
         *
         * @param string $url the url of image.
         * @param array $host contain server information ( using parse_url() function to return this value )
         * @access public,
         */
        function resizeLinkedImage($url, $host)
        {

            if (!is_dir($this->_imageBase . DS . 'linked_images' . DS)) {
                if (!mkdir($this->_imageBase . DS . 'linked_images' . DS, 0755)) {
                    return '';
                }
            }
            //	mkdir($this->_imageBase . DS . 'linked_images'.DS . $host['host'] . DS, 0755);
            //
            $filePath = $this->_imageBase . 'linked_images/' . $host['host'] . '/' . 'testthu.jpg';
            JFile::exists($filePath);
            $source = file_get_contents($url);
            JFile::write($filePath, $source);
            $files = 'images/linked_images/' . $host['host'] . '/testthu.jpg';

            $output = $this->resize($files, 160, 80);

            //	if( $this->_storeImage ){
            //	JFile::delete( $filePath  );
            //	}


            return $output;
        }


        /**
         * check the folder is existed, if not make a directory and set permission is 755
         *
         *
         * @param array $path
         * @access public,
         * @return boolean.
         */
        function makeDir($path)
        {
            $folders = explode('/', ($path));
            $tmppath = $this->_cachePath;
            for ($i = 0; $i < count($folders) - 1; $i++) {
                if (!file_exists($tmppath . $folders[$i]) && !JFolder::create($tmppath . $folders[$i], 0755)) {
                    return false;
                }
                $tmppath = $tmppath . $folders[$i] . DS;
            }
            return true;
        }


        /**
         * process render image
         *
         * @param string $imageSource is path of the image source.
         * @param stdClass $src the setting of image source
         * @param stdClass $dst the setting of image dts
         * @param string $imageCache path of image cache ( it's thumnail).
         * @access public,
         */
        function _resizeImage($imageSource, $src, $dst, $size, $imageCache)
        {
            // create image from source.
            $extension = $this->types[$size[2]];
            $image = call_user_func("imagecreatefrom" . $extension, $imageSource);

            if (function_exists("imagecreatetruecolor") && ($newimage = imagecreatetruecolor($dst->w, $dst->h))) {

                if ($extension == 'gif' || $extension == 'png') {
                    imagealphablending($newimage, false);
                    imagesavealpha($newimage, true);
                    $transparent = imagecolorallocatealpha($newimage, 255, 255, 255, 127);
                    imagefilledrectangle($newimage, 0, 0, $dst->w, $dst->h, $transparent);
                }

                imagecopyresampled($newimage, $image, $dst->x, $dst->y, $src->x, $src->y, $dst->w, $dst->h, $src->w, $src->h);
            } else {
                $newimage = imagecreate($src->w, $src->h);
                imagecopyresized($newimage, $image, $dst->x, $dst->y, $src->x, $src->y, $dst->w, $dst->h, $size[0], $size[1]);
            }

            switch ($extension) {
                case 'jpeg':
                    call_user_func('image' . $extension, $newimage, $imageCache, $this->_quality);
                    break;
                default:
                    call_user_func('image' . $extension, $newimage, $imageCache);
                    break;
            }
            // free memory
            imagedestroy($image);
            imagedestroy($newimage);
        }


        /**
         * set quality image will render.
         */
        function setQuality($number = 9)
        {
            $this->_quality = $number;
        }


        /**
         * check the image is a linked image from other server.
         *
         *
         * @param string the url of image.
         * @access public,
         * @return array if it' linked image, return false if not
         */
        function isLinkedImage($imageURL)
        {
            $parser = parse_url($imageURL);
            return strpos(JURI::base(), $parser['host']) ? false : $parser;
        }


        /**
         * check the file is a image type ?
         *
         * @param string $ext
         * @return boolean.
         */
        function isImage($ext = '')
        {
            return in_array($ext, $this->types);
        }


        /**
         * check the image source is existed ?
         *
         * @param string $imageSource the path of image source.
         * @access public,
         * @return boolean,
         */
        function sourceExited($imageSource)
        {

            if ($imageSource == '' || $imageSource == '..' || $imageSource == '.') {
                return false;
            }
            $imageSource = str_replace(JURI::base(), '', $imageSource);
            $imageSource = rawurldecode($imageSource);
            return (file_exists(JPATH_SITE . '/' . $imageSource));
        }


        /**
         * check the image source is existed ?
         *
         * @param string $imageSource the path of image source.
         * @access public,
         * @return boolean,
         */
        function parseImage($row)
        {
            //check to see if there is an  intro image or fulltext image  first
			$images = "";
			if (isset($row->images)) {
				$images = json_decode($row->images);
			}			
			if((isset($images->image_fulltext) and !empty($images->image_fulltext)) || (isset($images->image_intro) and !empty($images->image_intro))){
				$image = (isset($images->image_intro) and !empty($images->image_intro))?$images->image_intro:((isset($images->image_fulltext) and !empty($images->image_fulltext))?$images->image_fulltext:"");
			}
			else {
				$regex = '/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/';
				$text = '';
				$text .= (isset($row->fulltext))?$row->fulltext:'';
				$text .= (isset($row->introtext))?$row->introtext:'';
				preg_match($regex, $text, $matches);
				$images = (count($matches)) ? $matches : array();
				$image = count($images) > 1 ? $images[1] : '';
			}
			return $image;
        }
	}
}