<?php
/**
 * @version		$Id$
 * @author		NooTheme
 * @package		Joomla.Site
 * @subpackage	mod_noo_k2items
 * @copyright	Copyright (C) 2013 NooTheme. All rights reserved.
 * @license		License GNU General Public License version 2 or later; see LICENSE.txt, see LICENSE.php
 */

// no direct access
defined('_JEXEC') or die('Restricted access');
require_once __DIR__ . '/helper.php';
$document = JFactory::getDocument();

if (!defined('NOO_K2ITEMS_CSS')){
	$document->addStyleSheet('modules/' . $module->module . '/assets/css/jquery.bxslider.css');
	$document->addStyleSheet('modules/' . $module->module . '/assets/css/style.css');
	define('NOO_K2ITEMS_CSS',true);
}

$easing_type = trim($params->get('easing_type','easing_css')) == 'easing_css' ?'true':'false';
if(trim($params->get('easing_type','easing_css')) != 'easing_css'){
	if (!defined('NOO_JS_EASING')) {
		$document->addScript('modules/' . $module->module . '/assets/js/jquery.easing.1.3.js');
		define('NOO_JS_EASING', true);
	}
}
if (!defined('NOO_K2ITEMS_JS')){
	$document->addScript('modules/' . $module->module . '/assets/js/jquery.bxslider.js');
	define('NOO_K2ITEMS_JS',true);
}

// Get component params
$componentParams = JComponentHelper::getParams('com_k2');

$itemAuthorAvatarWidthSelect = $params->get('itemauthoravatarwidthselect','custom');
$itemAuthorAvatarWidth = $params->get('itemauthoravatarwidth', 50);
// User avatar
if ($itemAuthorAvatarWidthSelect == 'inherit')
{
    $avatarWidth = $componentParams->get('userImageWidth');
}
else
{
    $avatarWidth = $itemAuthorAvatarWidth;
}

$lists = modNooK2ItemsHelper::getList($params);


$easing = ($easing_type == 'false') ? $params->get('easing_js','swing') : $params->get('easing_css','linear');
$autorun = $params->get('autorun',1);
$infiniteLoop = $params->get('infiniteLoop',1);
$pager = $params->get('pager',1);
$controls = $params->get('controls',1);
$jsObject = "
	jQuery(document).ready(function($){
		$('#noo-k2i" . $module->id . "').bxSlider({
			mode:'".$params->get('mode','fade')."',
			useCSS:".$easing_type.",
			easing:'".$easing."',
			speed:".$params->get('animation_speed').",
			auto:".$autorun.",
			infiniteLoop:".$infiniteLoop.",
			pager:".$pager.",
			controls:".$controls.",
			touchEnabled:false,
			pause:".$params->get('animation_interval','4000')."
		});
	});
";
$document->addScriptDeclaration($jsObject);
require (JModuleHelper::getLayoutPath('mod_noo_k2items',$params->get('layout', 'default')));