/**
 * @version		$Id$
 * @author		NooTheme
 * @package		Joomla.Site
 * @subpackage	mod_noo_slider2
 * @copyright	Copyright (C) 2013 NooTheme. All rights reserved.
 * @license		License GNU General Public License version 2 or later; see LICENSE.txt, see LICENSE.php
 */

(function($) {
	$.fn.nooslider2 = function(options){
		var defaults = {
				speed			: 300,
				interval        : 1000,
				easing			: null,
				auto			:false
			};
		var options = $.extend(defaults, options);
		return this.each(function() {
			var element 	= $(this),
				inner   	= element.find('.noo-s2-inner'),
				slider  	= element.find('ul'),
				slide    	= element.find('.item'),
				total   	= slide.size(),
				btnNext 	= element.find('.next'),
				btnPrev		= element.find('.prev'),
				running 	= false,
				interval;
	
			$(slide[1]).addClass('active');
			
			inner.css({
				'margin':'0 auto'
			});

			slider.css({
				'width':100*total+'%',
				'position': 'relative',
				'left':'-100%'
			});
			slide.css({
				'width':100/total+'%',
				'float':'left'
			});
			
			if ( $.browser.msie ){
				$('.noo-s2-control').addClass('cs-btn-ie');
			};
			
			if(options.auto){
				run();
				element.bind('mouseenter',function(){
					pause();
				});
			    element.bind('mouseleave',function(){
			    	run();
			    })
			}
			
			if(btnNext){
				btnNext.bind('click',function(){
					next();
				})
			}
			if(btnPrev){
				btnPrev.bind('click',function(){
					prev();
				})
			}
			
			function getActiveIndex(){
			  		var curr = element.find('.item.active');
			  		items = slider.children();
			        return items.index(curr);
			};
			function prev(){
				if(running)
					return;
			
				go('prev');
			};
			function next(){
				if(running)
					return;
			
				go('next');
			};
			function run(){
				pause();
				interval = setInterval(function() {
					next();
				},options.interval);
			};
			function pause(){
				clearInterval(interval);
				interval = null;
			};
			function go(type,to){
				var active = element.find('.item.active'),
					to = to || active[type](),
					fallback  = type == 'next' ? 'first' : 'last',
					direction = type == 'next' ? 'left' : 'right';

				
				running = true;
				
				to = to.length ? to : element.find('.item')[fallback]();
				
				if (to.hasClass('active')) 
					return;
				
				active.removeClass('active');
				to.addClass('active').css('opacity',1).css('filter','alpha(opacity=100)');
				slide.css('opacity',0.5);
				slide.css('filter','alpha(opacity=50)');
				if(type == 'next'){
					to.next().css('opacity',0);
					to.next().css('filter','alpha(opacity=50)');
				}
				slider.animate({left: -(getActiveIndex()*100)+'%'},options.speed, options.easing,
							function() {
								if(type == 'next'){
									 to.next().css({'opacity':0.5});
									 to.next().css('filter','alpha(opacity=50)');
									 $('.item:last',element).after($('.item:first',element));
									 
								}else{
									 $('.item:first',element).before($('.item:last',element));
								}
								slider.css({'left':(-100)+'%'});
								running = false;
							}
						);
			};
		});
	};
})(jQuery);

