/**
 * @version		$Id$
 * @author		NooTheme
 * @package		Joomla.Site
 * @subpackage	mod_noo_weather
 * @copyright	Copyright (C) 2013 NooTheme. All rights reserved.
 * @license		License GNU General Public License version 2 or later; see LICENSE.txt, see LICENSE.php
 */

!function ($){
	$.fn.nooweather = function(options) {
		var defaults = {
			unit: 'c',
			image: true,
			country: false,
			highlow: true,
			wind: true,
			humidity: false,
			visibility: false,
			sunrise: false,
			sunset: false,
			forecast: false,
			link: true,
			showerror: true,
			linktarget: '_self',
			woeid: false
		};  
		var options = $.extend(defaults, options); 
		return this.each(function() {
			// Cache results for an hour to prevent overuse
			
			var element = $(this);
			
			var cityList = element.find('.listCity');
			
			if(!cityList)
				return;
				
			var now = new Date();
			
			// Select location ID type
			var queryType = options.woeid ? 'woeid' : 'location';
					
			var locationid = cityList.val();
			// Create Yahoo Weather feed API address
			
			var url  = _createUrl(locationid);
			_callApi(url);
			
			cityList.change(function(){
				url = _createUrl($(this).val());
				_callApi(url);
			});
			
			function _createUrl(localtionId){
				var query = "select * from weather.forecast where "+ queryType +" = '"+ localtionId +"' and u='"+ options.unit +"'";
				var api = 'http://query.yahooapis.com/v1/public/yql?q='+ encodeURIComponent(query) +'&rnd='+ now.getFullYear() + now.getMonth() + now.getDay() + now.getHours() +'&format=json&callback=?';
				return api;
			};
			function _getTimeAsDate(t){
				d = new Date();
				r = new Date(d.toDateString() +' '+ t);
				return r;
			};
			function _processOutput(data){
				if (data.description != 'Yahoo! Weather Error') {
					var wd = data.wind.direction;
					if (wd>=348.75&&wd<=360){wd="N"};if(wd>=0&&wd<11.25){wd="N"};if(wd>=11.25&&wd<33.75){wd="NNE"};if(wd>=33.75&&wd<56.25){wd="NE"};if(wd>=56.25&&wd<78.75){wd="ENE"};if(wd>=78.75&&wd<101.25){wd="E"};if(wd>=101.25&&wd<123.75){wd="ESE"};if(wd>=123.75&&wd<146.25){wd="SE"};if(wd>=146.25&&wd<168.75){wd="SSE"};if(wd>=168.75&&wd<191.25){wd="S"};if(wd>=191.25 && wd<213.75){wd="SSW"};if(wd>=213.75&&wd<236.25){wd="SW"};if(wd>=236.25&&wd<258.75){wd="WSW"};if(wd>=258.75 && wd<281.25){wd="W"};if(wd>=281.25&&wd<303.75){wd="WNW"};if(wd>=303.75&&wd<326.25){wd="NW"};if(wd>=326.25&&wd<348.75){wd="NNW"};
					var wf = data.item.forecast[0];
					wpd = data.item.pubDate;
					n = wpd.indexOf(":");
					tpb = _getTimeAsDate(wpd.substr(n-2,8));
					tsr = _getTimeAsDate(data.astronomy.sunrise);
					tss = _getTimeAsDate(data.astronomy.sunset);
	
					if (tpb>tsr && tpb<tss) { daynight = 'day'; } else { daynight = 'night'; }
					
			
					var html = '';
					if (options.image){
						element.find('.weatherImage').css({
						'background-image':'url(http://l.yimg.com/a/i/us/nws/weather/gr/'+ data.item.condition.code + daynight.substring(0,1) +'.png)',
						'background-repeat':'no-repeat'
						});
					}
			
					// Add item data
					if (options.country) html += '<div class="weatherCountry">'+ data.location.country +'</div>';
					html += '<div class="weatherTemp">'+ data.item.condition.temp +'&deg;'+ options.unit +'</div>';
					html += '<div class="weatherDesc">'+ data.item.condition.text +'</div>';
					
					// Add optional data
					if (options.highlow) html += '<div class="weatherRange">High: '+ wf.high +'&deg; Low: '+ wf.low +'&deg;</div>';
					if (options.wind) html += '<div class="weatherWind">Wind: '+ wd +' '+ data.wind.speed + data.units.speed +'</div>';
					if (options.humidity) html += '<div class="weatherHumidity">Humidity: '+ data.atmosphere.humidity +'</div>';
					if (options.visibility) html += '<div class="weatherVisibility">Visibility: '+ data.atmosphere.visibility +'</div>';
					if (options.sunrise) html += '<div class="weatherSunrise">Sunrise: '+ data.astronomy.sunrise +'</div>';
					if (options.sunset) html += '<div class="weatherSunset">Sunset: '+ data.astronomy.sunset +'</div>';
	
					// Add item forecast data
					if (options.forecast) {
						html += '<div class="weatherForecast">';
						var wfi = data.item.forecast;
						for (var i=0; i<wfi.length; i++) {
							html += '<div class="weatherForecastItem" style="background-image: url(http://l.yimg.com/a/i/us/nws/weather/gr/'+ wfi[i].code +'s.png); background-repeat: no-repeat;">';
							html += '<div class="weatherForecastDay">'+ wfi[i].day +'</div>';
							html += '<div class="weatherForecastDate">'+ wfi[i].date +'</div>';
							html += '<div class="weatherForecastText">'+ wfi[i].text +'</div>';
							html += '<div class="weatherForecastRange">High: '+ wfi[i].high +' Low: '+ wfi[i].low +'</div>';
							html += '</div>'
						}
						html += '</div>'
					}
	
					if (options.link) html += '<div class="weatherLink"><a href="'+ data.link +'" target="'+ options.linktarget +'" title="Read full forecast" rel="nofollow">Full forecast</a></div>';
	
					element.find('.weatherInfo').html(html);
				}
			};
			function _callApi(api){
				// Send request
				$.ajax({
					type: 'GET',
					url: api,
					dataType: 'json',
					success: function(data) {

						if (data.query && data.query.results.channel.description != 'Yahoo! Weather Error') {
							_processOutput(data.query.results.channel);
						} else {
							if (options.showerror) element.html('<p>Weather information unavailable</p>');
						}
					},
					error: function(data) {
						if (options.showerror) element.html('<p>Weather request failed</p>');
					}
				});
			}
		});
	};
}(window.jQuery)