<?php
/**
 * @package   T3 Blank
 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
$sitename = $this->params->get('sitename') ? $this->params->get('sitename') : JFactory::getConfig()->get('sitename');
$slogan = $this->params->get('slogan');
$logotype = $this->params->get('logotype', 'text');
$logoimage = $logotype == 'image' ? $this->params->get('logoimage', '') : '';
if ($logoimage) {
  $logoimage = ' style="background-image:url('.JURI::base(true).'/'.$logoimage.');"';
}
?>

<!-- HEADER -->
<header id="t3-header" class="container t3-header">
  <div class="row">
	
	<?php if ($this->countModules('position-2')) : ?>
	<div class="col-md-3 background-header">
		<jdoc:include type="modules" name="<?php $this->_p('position-2') ?>" style="raw" />
	</div>
	<?php endif ?>
	
    <!-- LOGO -->
    <div class="col-md-6 logo">
		<div id="date"><?php echo JHTML::Date( 'now', 'DATE_FORMAT_LC1' ); ?></div>
		<div class="logo-<?php echo $logotype ?>">
			<h1>
				<a href="<?php echo JURI::base(true) ?>" title="<?php echo strip_tags($sitename) ?>"<?php echo $logoimage ?>>
					<span><?php echo $sitename ?></span>
				</a>
				<small class="site-slogan hidden-phone"><?php echo $slogan ?></small>
			</h1>
		</div>
    </div>
    <!-- //LOGO -->

    <?php if ($this->countModules('weather')) : ?>
    <!-- HEAD SEARCH -->
    <div class="col-md-3 weather<?php $this->_c('weather')?>">
		<div class="main-weather">
			<jdoc:include type="modules" name="<?php $this->_p('weather') ?>" style="raw" />
		</div>
		<div class="jux-language">
         	<jdoc:include type="modules" name="<?php $this->_p('languages') ?>" style="raw" />
    	</div>	
    </div>
    <!-- //HEAD SEARCH -->
    
    <?php endif ?>

  </div>
</header>
<!-- //HEADER -->
